{****************************************************************************}
{                             (c) Petr SIMANDL                               }
{                             simandl@mujmail.cz                             }
{                     www.micro.feld.cvut.cz/~simandl                        }
{                          members/xoom.com/simandl                          }
{****************************************************************************}
{ Uprava HPGL vystupniho souboru z OrCADu 386. Upraveny vystup lze jiz poslat}
{ na ploter a kreslit primo na cuprextit, nebo masku pro fotocestu.          }
{****************************************************************************}
program CUDIRECT;
uses Dos,Crt;

{$I-}
label KONEC;
const
  EXTIN  = '.PLT';
  EXTOUT = '.PLP';
  ANGLE  = 40;          {velikost useku oblouku}
  LMIN   = 30;          {delka odstranovanych car}
  ZNLN   = 20;          {delka odstranovany car v zonach}
  XMAX   = 10612;       { rozmer     }
  YMAX   = 7721;        {         A4 }

type
  CMDTYPE = record
              PRIKAZ : string [2];
              PAR1   : integer;
              PAR2   : integer;
              PAR3   : integer;
              PAR4   : integer;
            end;
  SPOJ = ^ZAZNAM;
  ZAZNAM = record
             DALSI                 : SPOJ;
             TYP                   : byte;
             VELIKOST,X1,Y1,X2,Y2  : real;
           end;

var
  INFILE,OUTFILE  : text;
  INNAME,OUTNAME  : pathstr;
  A               : char;
  CNT             : byte;
  PARS            : string[10];
  X,Y,BX,BY       : integer;
  RCD             : integer;
  CMD             : CMDTYPE;
  ACMD,BCMD,CCMD  : CMDTYPE;
  ERR,KL          : boolean;
  DIRS            : dirstr;
  NAMES           : namestr;
  EXTS            : extstr;
  SEARCHR         : searchrec;
  FIRST,P,NEXT,L  : SPOJ;
  NRNP,NRCP,NZ,
  NLN,NA,NE       : word;
  COSA,SINA,
  X1,Y1,X2,Y2,
  PX,PY,R,RL      : real;
  DX1,DY1,DX2,DY2 : integer;
  XOFS,YOFS       : integer;
  REDEFTYPE       : byte;
  REDEFSIZE       : integer;
  REDEFLINE       : byte;

{****************************************************************************}
{ ZDE SE ZE VSTUPNIHO SOUBORU VYBIRAJI JEDNOTLIVE PRVKY A UKLADAJI DO PAMETI }
{****************************************************************************}
procedure GETONEPAR;
begin
  PARS:='0';
  read(INFILE,A);
  while not(eof(INFILE) or (A=',') or (A=';')) do begin
                                                    PARS:=PARS+A;
                                                    read(INFILE,A);
                                                  end;
end;

procedure GETPAR;
begin
  GETONEPAR;
  val(PARS,CMD.PAR1,RCD);
  if not(eof(INFILE) or (A=';')) then begin
                                        GETONEPAR;
                                        val(PARS,CMD.PAR2,RCD);
                                      end;
  if not(eof(INFILE) or (A=';')) then begin
                                        GETONEPAR;
                                        val(PARS,CMD.PAR3,RCD);
                                      end;
  if not(eof(INFILE) or (A=';')) then begin
                                        GETONEPAR;
                                        val(PARS,CMD.PAR4,RCD);
                                      end;
end;

procedure ROUNDPAD;
begin
  X:=CMD.PAR1;
  Y:=CMD.PAR2;
  BX:=CCMD.PAR1;
  BY:=CCMD.PAR2;
  new(NEXT);
  P^.DALSI    := NEXT;
  P^.TYP      := 1;
  P^.VELIKOST := round(sqrt(sqr(BX-X)+sqr(BY-Y)));
  P^.X1       := X;
  P^.Y1       := Y;
  P^.X2       := 0;
  P^.Y2       := 0;
  P:=NEXT;
  P^.TYP:=0;
end;

procedure RECTPAD;
begin
  X:=round((CMD.PAR1+BCMD.PAR1)/2);
  Y:=round((CMD.PAR2+BCMD.PAR2)/2);
  BX:=X;
  BY:=CMD.PAR2;
  new(NEXT);
  P^.DALSI    := NEXT;
  P^.TYP      := 2;
  P^.VELIKOST := round(sqrt(sqr(BX-X)+sqr(BY-Y)));
  P^.X1       := X;
  P^.Y1       := Y;
  P^.X2       := 0;
  P^.Y2       := 0;
  P:=NEXT;
  P^.TYP:=0;
end;

procedure NET;
begin
  X:=CMD.PAR1;
  Y:=CMD.PAR2;
  BX:=ACMD.PAR1;
  BY:=ACMD.PAR2;
  new(NEXT);
  P^.DALSI    := NEXT;
  P^.TYP      := 3;
  P^.VELIKOST := round(sqrt(sqr(CCMD.PAR1-X)+sqr(CCMD.PAR2-Y)));
  P^.X1       := BX;
  P^.Y1       := BY;
  P^.X2       := X;
  P^.Y2       := Y;
  P:=NEXT;
  P^.TYP:=0;
end;

procedure ZONE;
begin
  X1:=CCMD.PAR1;
  Y1:=CCMD.PAR2;
  X2:=ACMD.PAR1;
  Y2:=ACMD.PAR2;
  if (sqrt(sqr(X2-X1)+sqr(Y2-Y1))>ZNLN) and
     (Y1<>Y2)                         then begin
                                             X:=CCMD.PAR1;
                                             Y:=CCMD.PAR2;
                                             BX:=ACMD.PAR1;
                                             BY:=ACMD.PAR2;
                                             new(NEXT);
                                             P^.DALSI    := NEXT;
                                             P^.TYP      := 4;
                                             P^.VELIKOST := 0;
                                             P^.X1       := BX;
                                             P^.Y1       := BY;
                                             P^.X2       := X;
                                             P^.Y2       := Y;
                                             P:=NEXT;
                                             P^.TYP:=0;
                                           end;
end;

procedure ANALYZA;
begin
  writeln('analyzuji vstupni soubor ...');
  new(FIRST);P:=FIRST;P^.TYP:=0;
  ACMD.PRIKAZ:='';BCMD.PRIKAZ:='';CCMD.PRIKAZ:='';
  while not eof(INFILE) do
    begin
      read(INFILE,CMD.PRIKAZ);
      GETPAR;
      if (ACMD.PRIKAZ='AA') and
         (BCMD.PRIKAZ='AA') and
         (CCMD.PRIKAZ='PA') and
         (CMD.PRIKAZ='AA') then NET;
      if (ACMD.PRIKAZ='PD') and
         (BCMD.PRIKAZ='AA') and
         (CCMD.PRIKAZ='PA') and
         (CMD.PRIKAZ='AA') then ROUNDPAD;
      if (ACMD.PRIKAZ='PD') and
         (BCMD.PRIKAZ='PA') and
         (CCMD.PRIKAZ='PA') and
         (CMD.PRIKAZ='PA') then RECTPAD;
      if (ACMD.PRIKAZ='PA') and
         (BCMD.PRIKAZ='PD') and
         (CCMD.PRIKAZ='PA') and
         (CMD.PRIKAZ='PU') then ZONE;
      ACMD:=BCMD;BCMD:=CCMD;CCMD:=CMD;
      while (not eof(INFILE)) and (A<>';') do read(INFILE,A);
    end;
end;

{****************************************************************************}
{ SPOCITA JEDNOTLIVE PRVKY A ZOBRAZI TYTO UDAJE NA OBRAZOVKU                 }
{****************************************************************************}
procedure STATISTIKA;
begin
  NRNP:=0;NRCP:=0;NLN:=0;NA:=0;NE:=0;NZ:=0;
  DX1:=15000;DY1:=15000;
  DX2:=0;DY2:=0;
  P:=FIRST;
  while P^.TYP<>0 do begin
                       if P^.X1<DX1 then DX1:=round(P^.X1);
                       if P^.X2<DX1 then DX1:=round(P^.X2);
                       if P^.Y1<DY1 then DY1:=round(P^.Y1);
                       if P^.Y2<DY1 then DY1:=round(P^.Y2);
                       if P^.X1>DX2 then DX2:=round(P^.X1);
                       if P^.X2>DX2 then DX2:=round(P^.X2);
                       if P^.Y1>DY2 then DY2:=round(P^.Y1);
                       if P^.Y2>DY2 then DY2:=round(P^.Y2);
                       inc(NA);
                       case P^.TYP of
                         1   : inc(NRNP);
                         2   : inc(NRCP);
                         3   : inc(NLN);
                         4   : inc(NZ);
                         255 : inc(NE);
                       end;
                       P:=P^.DALSI;
                     end;
  writeln('pocet ovalnych padu      : ',NRNP);
  writeln('pocet obdelnikovych padu : ',NRCP);
  writeln('pocet spoju              : ',NLN);
  writeln('pocet spoju v zonach     : ',NZ);
  writeln('pocet zrusenych prvku    : ',NE);
  writeln('celkovy pocet prvku      : ',NA);
  writeln('Xmin = ',DX1,'   Ymin = ',DY1);
  writeln('Xmax = ',DX2,'   Ymax = ',DY2);

end;

{****************************************************************************}
{ ODSEKAVANI CAR ZASAHUJICICH DOVNITR PAJECICH BODU NA OKRAJ TECHTO PADU     }
{****************************************************************************}
procedure GETSINCOS;
begin
  X1:=L^.X1;Y1:=L^.Y1;
  X2:=L^.X2;Y2:=L^.Y2;
  PX:=P^.X1;PY:=P^.Y1;
  R:=P^.VELIKOST;
  if X2-X1<>0
    then COSA:=sqrt(sqr(X2-X1)/(sqr(X2-X1)+sqr(Y2-Y1)))*(X2-X1)/abs(X2-X1)
    else COSA:=0;
  if Y2-Y1<>0
    then SINA:=sqrt(sqr(Y2-Y1)/(sqr(X2-X1)+sqr(Y2-Y1)))*(Y2-Y1)/abs(Y2-Y1)
    else SINA:=0;
  if (COSA=0) and (SINA=0)
    then L^.TYP:=255
    else begin
           if P^.TYP=2 then
             begin
               if abs(COSA)>abs(SINA) then R:=P^.VELIKOST/abs(COSA)
                                      else R:=P^.VELIKOST/abs(SINA);
             end;
         end;
end;

procedure CUTRO1;
begin
  GETSINCOS;
  L^.X1:=round(L^.X1+R*COSA);
  L^.Y1:=round(L^.Y1+R*SINA);
end;

procedure CUTRO2;
begin
  GETSINCOS;
  COSA:=-COSA;
  SINA:=-SINA;
  L^.X2:=round(L^.X2+R*COSA);
  L^.Y2:=round(L^.Y2+R*SINA);
end;


function INCENTERPAD(X1,Y1,X2,Y2:real):boolean;
begin
  if sqrt(sqr(X2-X1)+sqr(Y2-Y1))<(P^.VELIKOST*0.5) then INCENTERPAD:=true
                                                   else INCENTERPAD:=false;
end;


procedure CUTROUND;
begin
  L:=FIRST;
  while L^.TYP<>0 do
  begin
    if L^.TYP=3
    then begin
           if INCENTERPAD(P^.X1,P^.Y1,L^.X1,L^.Y1) then CUTRO1;
           if INCENTERPAD(P^.X1,P^.Y1,L^.X2,L^.Y2) then CUTRO2;
         end;
    L:=L^.DALSI;
  end;
end;


procedure CUTLINES;
begin
  writeln('orezavam cary zasahujici do padu ...');
  P:=FIRST;
  while P^.TYP<>0 do begin
                       if P^.TYP=1 then CUTROUND;
                       if P^.TYP=2 then CUTROUND;
                       P:=P^.DALSI;
                     end;
end;

{****************************************************************************}
{ ODSTRANENI CAR JEZ ZASAHUJI DO PADU                                        }
{****************************************************************************}

function INPAD(X1,Y1,X2,Y2:real):boolean;
begin
  if sqrt(sqr(X2-X1)+sqr(Y2-Y1))<(P^.VELIKOST*0.9) then INPAD:=true
                                                   else INPAD:=false;
end;

procedure CUTINONE;
begin
  L:=FIRST;
  while L^.TYP<>0 do
  begin
    if (L^.TYP=3) and
       (INPAD(P^.X1,P^.Y1,L^.X1,L^.Y1) or
       INPAD(P^.X1,P^.Y1,L^.X2,L^.Y2)) then L^.TYP:=255;
    L:=L^.DALSI;
  end;
end;

procedure KILLINPAD; {cary s obema koncema v padu zrusim}
begin
  writeln('rusim cary v padech ...');
  NE:=0;
  P:=FIRST;
  while P^.TYP<>0 do begin
                       if P^.TYP=1 then CUTINONE;
                       if P^.TYP=2 then CUTINONE;
                       P:=P^.DALSI;
                     end;
end;

{****************************************************************************}
{ Z PAMETI SE POSTUPNE VYBIRAJI PRVKY A POSILAJI SE NA VYSTUP                }
{****************************************************************************}
procedure SYNTROUNDPAD;
begin
  BX:=round(P^.X1+P^.VELIKOST);
  BY:=round(P^.Y1);
  X:=round(P^.X1);
  Y:=round(P^.Y1);
  write(OUTFILE,'pa',BX,',',BY,';pd;aa',X,',',Y,',360,',ANGLE,';pu;');
end;

procedure SYNTRECTPAD;
begin
  BX:=round(P^.X1+P^.VELIKOST);
  BY:=round(P^.Y1+P^.VELIKOST);
  X:=round(2*P^.VELIKOST);
  Y:=round(2*P^.VELIKOST);
  write(OUTFILE,'pa',BX,',',BY,';pd;pr0,',-Y,';pr',-X,',0;pr0,',Y,';pr',X,',0;pu;pa;');
end;

procedure SYNTLINE;
begin
  BX:=round(P^.X1);
  BY:=round(P^.Y1);
  X:=round(P^.X2);
  Y:=round(P^.Y2);
  L:=P^.DALSI;
  if (P^.X2=L^.X1) and (P^.Y2=L^.Y1) and (L^.TYP=3)
    then write(OUTFILE,'pa',BX,',',BY,';pd;pa',X,',',Y,';')
    else write(OUTFILE,'pa',BX,',',BY,';pd;pa',X,',',Y,';pu;');
end;

procedure SYNTZONE;
begin
  BX:=round(P^.X1);
  BY:=round(P^.Y1);
  X:=round(P^.X2);
  Y:=round(P^.Y2);
  L:=P^.DALSI;
  if (P^.X2=L^.X1) and (P^.Y2=L^.Y1) and (L^.TYP=3)
    then write(OUTFILE,'pa',BX,',',BY,';pd;pa',X,',',Y,';')
    else write(OUTFILE,'pa',BX,',',BY,';pd;pa',X,',',Y,';pu;');
end;

procedure SYNTEZA;
begin
  writeln('zapisuji vysledek na vystup ...');
  write(OUTFILE,'%-1BBPIN;PS4;IW;PU;PA;SP1;');
  P:=FIRST;
  while P^.TYP<>0 do begin
                       case P^.TYP of
                         1 : SYNTROUNDPAD;
                         2 : SYNTRECTPAD;
                         3 : SYNTLINE;
                         4 : SYNTZONE;
                       end;
                       P:=P^.DALSI;
                     end;
  write(OUTFILE,'PU;PA0,10000;SP0;');
end;

{****************************************************************************}
{ UMOZNI VLOZIT UZIVATELI UDAJE PRO MODIFIKACI JEDNOTLIVYCH PRVKU            }
{****************************************************************************}
procedure NASTAVENI;
begin
  STATISTIKA;
  XOFS:=round((XMAX-DX2)/2);YOFS:=round((YMAX-DY2)/2);
  writeln;
  writeln('Zmenit umisteni v ose x (Stred, sipky nebo Enter)');
  repeat
    write('XOFS = ',XOFS,'     ');
    gotoxy(1,wherey);
    A:=readkey;
    if A=chr(0) then begin
                       A:=readkey;
                       if A=chr(77) then XOFS:=round(XMAX-DX2);
                       if A=chr(75) then XOFS:=0;
                     end
                else begin
                       if (A='s') or (A='S') then XOFS:=round((XMAX-DX2)/2);
                       if A=chr(13) then write('Volba : ');
                     end;
    write('XOFS = ',XOFS,'     ');
    gotoxy(1,wherey);
  until A=chr(13);
  writeln;
  writeln('Zmenit umisteni v ose y (Stred, sipky nebo Enter)');
  repeat
    write('YOFS = ',YOFS,'     ');
    gotoxy(1,wherey);
    A:=readkey;
    if A=chr(0) then begin
                       A:=readkey;
                       if A=chr(72) then YOFS:=round(YMAX-DY2);
                       if A=chr(80) then YOFS:=0;
                     end
                else begin
                       if (A='s') or (A='S') then YOFS:=round((YMAX-DY2)/2);
                       if A=chr(13) then write('Volba : ');
                     end;
    write('YOFS = ',YOFS,'     ');
    gotoxy(1,wherey);
  until A=chr(13);
  writeln;
  REDEFTYPE:=1;
  writeln('Zmenit typ vsech padu (Kolecko, Obdelnik, Ponechat nebo Enter)');
  repeat
    case REDEFTYPE of
      0 : write('Ponechat puvodni tvary    ');
      1 : write('Zmenit pady na ovalne     ');
      2 : write('Zmenit pady na obdelnikove');
    end;
    gotoxy(1,wherey);
    A:=readkey;
    if A=chr(0) then A:=readkey
                else begin
                       if (A='k') or (A='K') then REDEFTYPE:=1;
                       if (A='o') or (A='O') then REDEFTYPE:=2;
                       if (A='p') or (A='P') then REDEFTYPE:=0;
                       if A=chr(13) then write('Volba : ');
                     end;
    case REDEFTYPE of
      0 : write('Ponechat puvodni tvary    ');
      1 : write('Zmenit pady na ovalne     ');
      2 : write('Zmenit pady na obdelnikove');
    end;
    gotoxy(1,wherey);
  until A=chr(13);
  writeln;
  REDEFSIZE:=30;
  writeln('Zmenit velikost vsech padu (Sipky, Ponechat nebo Enter)');
  repeat
    if REDEFSIZE=0 then write('Ponechat puvodni velikost                  ')
                   else write('Zmenit velikost vsech padu na ',2*REDEFSIZE,' milu   ');
    gotoxy(1,wherey);
    A:=readkey;
    if A=chr(0) then begin
                       A:=readkey;
                       if (A=chr(72))and(REDEFSIZE<100) then inc(REDEFSIZE);
                       if (A=chr(80))and(REDEFSIZE>0)   then dec(REDEFSIZE);
                     end
                else begin
                       if (A='p') or (A='P') then REDEFSIZE:=0;
                       if A=chr(13) then write('Volba : ');
                     end;
    if REDEFSIZE=0 then write('Ponechat puvodni velikost                  ')
                   else write('Zmenit velikost vsech padu na ',2*REDEFSIZE,' milu   ');
    gotoxy(1,wherey);
  until A=chr(13);
  writeln;
  REDEFLINE:=0;
  writeln('Zmenit tloustku vsech car (Minimalizovat, Ponechat nebo Enter)');
{  repeat
    A:=readkey;
    if A=chr(0) then A:=readkey
                else begin
                       if (A='m') or (A='M') then REDEFLINE:=1;
                       if (A='p') or (A='P') then REDEFLINE:=0;
                       if A=chr(13) then write('Volba : ');
                     end;}
    case REDEFLINE of
      0 : write('Ponechat puvodni tloustky     ');
      1 : write('Vsechny kreslit jedinym tahem ');
    end;
    gotoxy(1,wherey);
{  until A=chr(13);}
  writeln;
end;

{****************************************************************************}
{ UPRAVA JEDNOTLIVYCH PRVKU PODLE PARAMETRU ZADANYCH UZIVATELEM              }
{****************************************************************************}
procedure UPRAVA;
begin
  writeln('provadim upravu prvku ...');
  P:=FIRST;
  while P^.TYP<>0 do
  begin
    P^.X1:=P^.X1+XOFS;
    P^.Y1:=P^.Y1+YOFS;
    P^.X2:=P^.X2+XOFS;
    P^.Y2:=P^.Y2+YOFS;
    case P^.TYP of
      1 : begin
            if REDEFTYPE=2 then P^.TYP:=2;
            if REDEFSIZE<>0 then P^.VELIKOST:=REDEFSIZE;
          end;
      2 : begin
            if REDEFTYPE=1 then P^.TYP:=1;
            if REDEFSIZE<>0 then P^.VELIKOST:=REDEFSIZE;
          end;
      3 : begin
            if REDEFLINE<>0 then P^.VELIKOST:=REDEFLINE;
          end;
    end;
    P:=P^.DALSI;
  end;
end;

{****************************************************************************}
{ OTEVRENI VSTUPNIHO A VYSTUPNIHO SOUBORU A JEJICH PRIPRAVA PRO CTENI A ZAPIS}
{****************************************************************************}
procedure OPENIT;
begin
  assign(INFILE,INNAME);
  assign(OUTFILE,OUTNAME);
  reset(INFILE);
  CNT:=IOResult;
  if CNT<>0 then begin
                   writeln('Nejde cist ',INNAME,' !');
                   ERR:=true;
                   close(INFILE);CNT:=IOResult;
                 end
                 else begin
                        rewrite(OUTFILE);
                        CNT:=IOResult;
                        if CNT<>0 then
                        begin
                          writeln('Nejde zalozit ',OUTNAME,' !');
                          ERR:=true;
                          close(OUTFILE);CNT:=IOResult;
                        end;
                      end;
end;

{****************************************************************************}
{ VYPIS NAPOVEDY PRO POUZITI PROGRAMU                                        }
{****************************************************************************}
procedure HELP;
begin
  writeln;
  writeln('(C) Petr Simandl 1/1997');
  writeln('Uprava HPGL vystupu z OrCADu 386');
  writeln('Vysledek lze jiz poslat na HPGL ploter, a kreslit primo na med.');
  writeln('Trpelivost prinasi ruze');
  writeln('Pouziti: CUDIRECT.EXE <soubor> [soubor/comX/lptX]');
end;

{****************************************************************************}
{ HLAVNI CAST PROGRAMU, KONTROLA PARAMETRU A SPOSTENI JEDNOTLIVYCH PROCEDUR  }
{****************************************************************************}
begin
  ERR:=false;
  case paramcount of
    0    : ERR:=true;
    1    : begin
             if (paramstr(1)='/?') or
                (paramstr(1)='/h') or
                (paramstr(1)='/H') then begin
                                          ERR:=true;
                                          goto KONEC;
                                        end;
             INNAME:=paramstr(1)+EXTIN;
             findfirst(INNAME,255,SEARCHR);
             if DosError<>0 then begin
                                   writeln('Soubor ',INNAME,' neexistuje !');
                                   ERR:=true;
                                   goto KONEC;
                                 end;
             fsplit(INNAME,DIRS,NAMES,EXTS);
             OUTNAME:=DIRS+NAMES+EXTOUT;
           end;
    2    : begin
             if (paramstr(1)='/?') or
                (paramstr(1)='/h') or
                (paramstr(1)='/H') then begin
                                          ERR:=true;
                                          goto KONEC;
                                        end;
             INNAME:=paramstr(1)+EXTIN;
             findfirst(INNAME,255,SEARCHR);
             if DosError<>0 then begin
                                   writeln('Soubor ',INNAME,' neexistuje !');
                                   ERR:=true;
                                   goto KONEC;
                                 end;
             OUTNAME:=paramstr(2)+EXTOUT;
           end;
    else begin
           if (paramstr(1)<>'/?') and
              (paramstr(1)<>'/h') and
              (paramstr(1)<>'/H') then writeln('Chybne parametry !');
           ERR:=true;
         end;
  end;

  if not ERR then OPENIT;
  if not ERR then begin
                    ANALYZA;
                    NASTAVENI;
                    UPRAVA;
                    CUTLINES;
                    KILLINPAD;
                    SYNTEZA;
                    STATISTIKA;
                    close(INFILE);
                    close(OUTFILE);
                  end;
KONEC:
  if ERR then HELP
         else writeln('Prevod probehl bez problemu.');
end.